<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h3 class="text-center mb-3 mt-3">Danh sách người dùng đăng ký</h3>
        <button id="btn-create" class="btn btn-success mt-2 mb-3 ">Thêm User</button>
        <table id="user-table" class="table table-bordered table-triped">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>First Name</th>
                    <th>Last Name</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>CustomerType</th>
                    <th>RegisterStatus</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>

    </div>

    <!-- Create voucher modal -->
    <div>
        <div id="create-voucher-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-voucher-code">firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-fname" name="vouchercodes" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-lname" name="discount" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-subject" name="discount" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="" id="select-country" class="form-control">
                                        <option value="">Chọn country</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">CuctomerType</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="" id="select-cutomer" class="form-control">
                                        <option value="">Chọn Customer</option>
                                        <option value="Standart">Standart</option>
                                        <option value="Gole">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>

                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-create-user">Create User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Update User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-voucher-code">firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-fname-up" name="vouchercodes" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-lname-up" name="discount" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="inp-subject-up" name="discount" placeholder=""
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="" id="select-country-up" class="form-control">
                                        <option value="">Chọn country</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">CuctomerType</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="" id="select-cutomer-up" class="form-control">
                                        <option value="">Chọn Customer</option>
                                        <option value="Standart">Standart</option>
                                        <option value="Gole">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>

                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
                        <button class="btn btn-primary" id="btn-update-user">Update User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>


</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    var gColName = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    const gCOL_ID = 0;
    const gCOL_FIRST_NAME = 1;
    const gCOL_LAST_NAME = 2;
    const gCOL_COUNTRY = 3;
    const gCOL_SUBJECT = 4;
    const gCOL_CUSTOMER_TYPE = 5;
    const gCOL_REGISTER_STATUS = 6;
    const gCOL_ACTION = 7;
    var gDataUser = null;



    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onLoadPage();

        $("#btn-create").on("click", function () {
            $("#create-voucher-modal").modal("show");
        })
        $("#btn-create-user").on("click", function () {
            onBtnCreateUser();
        })
        $("#user-table").on("click", ".btn-update", function () {

            $("#update-user-modal").modal("show");
            fillDataInputUpdate(this);

        })
        $("#btn-update-user").on("click", function () {
            onBtnUpdateUser();
        })

    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function fillDataTable(paramElement) {
        $("#user-table").DataTable({
            data: paramElement,
            columns: [
                { data: gColName[gCOL_ID] },
                { data: gColName[gCOL_FIRST_NAME] },
                { data: gColName[gCOL_LAST_NAME] },
                { data: gColName[gCOL_COUNTRY] },
                { data: gColName[gCOL_SUBJECT] },
                { data: gColName[gCOL_CUSTOMER_TYPE] },
                { data: gColName[gCOL_REGISTER_STATUS] },
                { data: gColName[gCOL_ACTION] },

            ],
            columnDefs: [
                {
                    targets: gCOL_ACTION,
                    defaultContent: "<button class='btn btn-success btn-update'>Sửa</button>" +
                        "<button class='ml-2 btn btn-danger btn-delete'>Xóa</button>"
                }
            ]
        })

    }

    function onLoadPage() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                fillDataTable(paramRes);
                // console.log(paramRes);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })
    }
    function onBtnDelete() {
        $("#user-table").on("click", ".btn-delete", function () {
            getDataBtn(this);
        })
    }

    function onBtnCreateUser() {
        var vUserObj = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customerType: "",
        }
        thuThapThongTin(vUserObj);

        var vCheck = validateDataUser(vUserObj);
        if (vCheck) {
            var vJsonUser = JSON.stringify(vUserObj);
            $.ajax({
                url: gBASE_URL,
                type: "POST",
                data: vJsonUser,
                contentType: gCONTENT_TYPE,
                success: function (paramRes) {
                    console.log(paramRes);
                    handleCreate();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }

            })
        }

    }
    function handleCreate() {
        alert("Thêm User Thành Công!");
        loadPageTime();
        clearInputUser();
        $("#create-voucher-modal").modal("hide");
    }

    function onBtnUpdateUser(paramDataUser) {
        var vUserObj = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customerType: "",
        }


        thuThapThongTinUpdateUser(vUserObj);

        $.ajax({
            url: gBASE_URL + gDataUser.id,
            type: "PUT",
            data: JSON.stringify(vUserObj),
            contentType: gCONTENT_TYPE,
            success: function (paramRes) {
                handleUpdate();

            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })

    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getDataBtn(paramElement) {
        var vRow = $(paramElement).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRow).data();

        return vDataRow;

    }
    function thuThapThongTin(paramUser) {
        paramUser.firstname = $("#inp-fname").val().trim();
        paramUser.lastname = $("#inp-lname").val().trim();
        paramUser.subject = $("#inp-subject").val().trim();
        paramUser.country = $("#select-country option:selected").text();
        paramUser.customerType = $("#select-customer option:selected").text();

    }
    function validateDataUser(paramUser) {
        if (paramUser.firstname == "" || paramUser.lastname == "" || paramUser.subject == "") {
            alert("Các trường khoong được bỏ trống!");
            return false;
        }
        else if (paramUser.country == "Chọn country") {
            alert("Chọn country!");
            return false;
        }
        else if (paramUser.customerType == "Chọn Customer") {
            alert("chọn customerType!");
            return false;
        }
        return true;
    }

    function clearInputUser() {
        $("#inp-fname").val("");
        $("#inp-lname").val("");
        $("#inp-subject").val("");
        $("#select-country option:selected").text("Chọn country");
        $("#select-customer option:selected").text("Chọn Customer");
    }
    function loadPageTime() {
        location.reload();
    }
    function fillDataInputUpdate(paramUpdate) {
        gDataUser = getDataBtn(paramUpdate);
        $("#inp-fname-up").val(gDataUser.firstname);
        $("#inp-lname-up").val(gDataUser.lastname);
        $("#inp-subject-up").val(gDataUser.subject);
        $("#select-country-up option:selected").text(gDataUser.country);
        $("#select-cutomer-up option:selected").text(gDataUser.customerType);
        console.log(gDataUser);
        console.log(gDataUser.firstname + " hello")

    }
    function thuThapThongTinUpdateUser(paramUser) {
        paramUser.firstname = $("#inp-fname-up").val().trim();
        paramUser.lastname = $("#inp-lname-up").val().trim();
        paramUser.subject = $("#inp-subject-up").val().trim();
        paramUser.country = $("#select-country-up option:selected").text();
        paramUser.customerType = $("#select-cutomer-up option:selected").text();
    }
    function handleUpdate() {
        alert("update user thành công!");
        loadPageTime();
        $("#update-user-modal").modal("hide");
    }



</script>

</html>